Rails.application.routes.draw do

  locales = Site.first.in_use_locales rescue I18n.available_locales

  scope "(:locale)", locale: Regexp.new(locales.join("|")) do
   namespace :admin do
      post 'news/get_preview_action', to: 'news#get_preview_action'
      post 'news/preview', to: 'news#preview'
      get 'news/destroy_preview/:slug_title-:uid', to: 'news#destroy_preview'
      get 'newsbulletins.json', to: 'newsbulletins#get_bulletins'
      post 'news/approve_news_bulletin', to: 'news#approve_news_bulletin'
      get 'news_admins/get_departments' => "news_admins#get_departments"
      get 'news/import_export', to: 'news#import_export'
      get 'news/download_file_from_thread', to: 'news#download_file_from_thread'
      post 'news/importnews', to: 'news#importnews'
      get 'news/excel_format', to: 'news#excel_format'
      get 'news/export_excel', to: 'news#export_excel'
      resources :news
      resources :news_admins
   end


   resources :news do
    collection do
      get ':slug_title-:uid', to: 'news#show', as: :display
    end
   end
  end

end
